<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container ">

    <div id="inputform01" class="jumbotron  ">
      <div class="row form-group ">
        <div class="col-sm-3  mb-2 ">
          <label for="tinh-select">Tỉnh thành phố</label>
        </div>
        <div class="col-sm-9   ">
          <select id="tinh-select" name="tinh" class="tinh-select form-control">
          </select>
        </div>
      </div>

      <div class="row form-group">
        <div class="col-sm-3">
          <label for="quan-huyen-select">Quận Huyện </label>
        </div>
        <div class="col-sm-9">
          <select name="quan" class="form-control quan-huyen-select">
          </select>
        </div>
      </div>

      <div class="row form-group">
        <div class="col-sm-3">
          <label for="phuong-xa-select-id">Phường xã</label>
        </div>
        <div class="col-sm-9">
          <select id="phuong-xa-select-id" name="phuong" class="phuong-xa-select form-control">
          </select>
        </div>
      </div>
      <!-- nút ấn  -->
      <div class="row pull-right">
        <div class="col-sm-12 ">
          <input type="button" value="Send" class="btn btn-info" id="send-button">
        </div>
      </div>
      <br>
      <br>
      <br>




      <div class="row">
        <h1>
          CRUD tỉnh thành phố
        </h1>
      </div>
      <!-- crud các đối tượng trên  -->
      <div class="row form-group ">
        <div class="col-sm-3 ">
          <label for="inp-ten-tinh">Tên tỉnh thanhd phố </label>
        </div>
        <div class="col-sm-9   ">
          <input id="inp-ten-tinh" class="form-control" type="text">
        </div>
      </div>

      <div class="row form-group ">
        <div class="col-sm-3 ">
          <label for="tinh-select">Mã tỉnh </label>
        </div>
        <div class="col-sm-9   ">
          <input id="inp-ma-tinh" class="form-control" type="text">
        </div>
      </div>
      <div class="row form-group ">
        <div class="col-sm-3 ">
          <label>Id tỉnh thành phố </label>
        </div>
        <div class="col-sm-9   ">
          <input id="inp-tinh-id" class="form-control" type="text">
        </div>
      </div>
      <div class="row form-group ">
        <div class="col-sm-3 ">
        </div>
        <div class="col-sm-9   ">
          <button id="btn-add-tinh" class="btn btn-info">Add</button>
          <button id="btn-cancel-tinh" class="btn btn-success">Cancel</button>
          <button id="btn-delete-tinh" class="btn btn-info">Delete</button>
          <button id="btn-update-tinh" class="btn btn-info">update</button>
        </div>
      </div>

      <!-- crud quận huyện -->
      <div class="row">
        <h1>
          CRUD quận huyện
        </h1>
      </div>
      <div class="row form-group ">
        <div class="col-sm-3 ">
          <label for="tinh-select">Tên quận huyện </label>
        </div>
        <div class="col-sm-9   ">
          <input id="ipn-ten-quan-huyen" class="form-control" type="text">
        </div>
      </div>

      <div class="row form-group ">
        <div class="col-sm-3 ">
          <label for="tinh-select">prefix </label>
        </div>
        <div class="col-sm-9   ">
          <input id="inp-prefix-quan-huyen" class="form-control" type="text">
        </div>
      </div>
      <div class="row form-group ">
        <div class="col-sm-3 ">
          <label for="tinh-select">Tên thành phố </label>
        </div>
        <div class="col-sm-9   ">
          <select id="tinh-select-id-quan-huyen" name="tinh" class="tinh-select form-control">
          </select>
        </div>
      </div>
      <div class="row form-group ">
        <div class="col-sm-3 ">
          <label for="tinh-select">Id quận huyện để xóa </label>
        </div>
        <div class="col-sm-9   ">
          <input id="inp-id-huyen-delete" class="form-control" type="text">
        </div>
      </div>
      <div class="row form-group ">
        <div class="col-sm-3 ">
        </div>
        <div class="col-sm-9   ">
          <button id="btn-add-huyen" class="btn btn-info">Add</button>
          <button id="btn-cancel-huyen" class="btn btn-success">Cancel</button>
          <button id="btn-delete-huyen" class="btn btn-info">Delete</button>
          <button id="btn-update-huyen" class="btn btn-info">update</button>
        </div>
      </div>


      <!-- crud Xã thị trấn -->
      <div class="row">
        <h1>
          CRUD xã thị trấn
        </h1>
      </div>
      <div class="row form-group ">
        <div class="col-sm-3 ">
          <label for="tinh-select">Tên xã thị trấn </label>
        </div>
        <div class="col-sm-9   ">
          <input id="inp-ten-thi-tran" class="form-control" type="text">
        </div>
      </div>

      <div class="row form-group ">
        <div class="col-sm-3 ">
          <label for="tinh-select">prefix </label>
        </div>
        <div class="col-sm-9   ">
          <input id="inp-prefix-thi-tran" class="form-control" type="text">
        </div>
      </div>
      <div class="row form-group ">
        <div class="col-sm-3 ">
          <label for="tinh-select-id">Tên thành phố </label>
        </div>
        <div class="col-sm-9   ">
          <select id="tinh-select-id-thi-tran" name="tinh" class="tinh-select form-control">
          </select>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="quan-huyen-select">Quận Huyện </label>
        </div>
        <div class="col-sm-9">
          <select id="id-quan-huyen-r" name="quan" class="form-control quan-huyen-select">
          </select>
        </div>
      </div>
      <div class="row form-group ">
        <div class="col-sm-3 ">
          <label for="tinh-select">Id quận huyện để xóa </label>
        </div>
        <div class="col-sm-9   ">
          <input id="inp-quan-huyen-delete" class="form-control" type="text">
        </div>
      </div>
      <div class="row form-group ">
        <div class="col-sm-3 ">
        </div>
        <div class="col-sm-9   ">
          <button id="btn-add-xa" class="btn btn-info">Add</button>
          <button id="btn-cancel-xa" class="btn btn-success">Cancel</button>
          <button id="btn-delete-xa" class="btn btn-info">Delete</button>
          <button id="btn-update-xa" class="btn btn-info">update</button>
        </div>
      </div>


    </div>
  </div>
  <script>


    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
      console.log("REGION 2");
      // khai báo các hàm nút ấn CRUD tỉnh thành phố
      $("#btn-add-tinh").click(addTinhClick);  //1 add
      $("#btn-delete-tinh").click(deldeteTinhClick);
      $("#btn-update-tinh").click(updateTinhClick);
      //CRUD quận huyện
      $("#btn-add-huyen").click(addHuyenClick);  //1 add
      $("#btn-delete-huyen").click(deldeteHuyenClick);
      $("#btn-update-huyen").click(updateHuyenClick);


    })


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */



    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/


    //  =================================================================
    //< CRUD tỉnh thành phố
    // 4 4 bước xử lý sự kiện 

    // thêm 
    function addTinhClick() {
      console.log("add tỉnh click");
      //1 đọc 
      console.log(getReadTinhData());
      var vData = getReadTinhData();
      //2 validate bỏ qua 
      //3 gọi api 
      $.ajax({
        type: "POST",
        url: "http://localhost:8080/provinces/create",
        data: JSON.stringify(vData),
        contentType: "application/json;charset=UTF-8",
        success: function (response) {
          console.log(response);
        }
      });
    }

    //   update 
    function updateTinhClick() {
      console.log("update tỉnh click");
      //1 đọc 

      var vData = getReadTinhData();
      console.log(vData);
      //2 validate bỏ qua 
      if (vData.id != "") {
        console.log("id khác rỗng ")
        //3 gọi api 
        $.ajax({
          type: "PUT",
          url: "http://localhost:8080/provinces/update/" + vData.id,
          data: JSON.stringify(vData),
          contentType: "application/json;charset=UTF-8",
          success: function (response) {
            console.log(response);
          },
          error: function (e) {
            console.log(e); // in error state
          }

        });
      }
    }

    // xóa đối tượng 

    function deldeteTinhClick() {
      console.log("delete tỉnh click");
      //1 đọc 

      var vData = getReadTinhData();
      console.log(vData);
      //2 validate bỏ qua 
      if (vData.id != "") {
        console.log("id khác rỗng ")
        //3 gọi api 
        $.ajax({
          type: "DELETE",
          url: "http://localhost:8080/provinces/delete/" + vData.id,

          success: function (response) {
            console.log(response);
          },
          error: function (e) {
            console.log(e); // in error state
          }

        });
      }
    }

    // > CRUD tỉnh thành phố
    //  =================================================================
   

    //  =================================================================
    //< CRUD tỉnh thành phố

     // 4 4 bước xử lý sự kiện 

    // thêm 
    function addHuyenClick() {
      console.log("add huyen click");
      //1 đọc 
      console.log(getReadHuyenData());
      var vData = getReadHuyenData();
      //2 validate bỏ qua 
      //3 gọi api 
      $.ajax({
        type: "POST",
        url: "http://localhost:8080/district/create",
        data: JSON.stringify(vData),
        contentType: "application/json;charset=UTF-8",
        success: function (response) {
          console.log(response);
        }
      });
    }

    //   update 
    function updateHuyenClick() {
      console.log("update huyen click");
      //1 đọc 

      var vData = getReadHuyenData();
      console.log(vData);
      //2 validate bỏ qua 
      if (vData.id != "") {
        console.log("id khác rỗng ")
        //3 gọi api 
        $.ajax({
          type: "PUT",
          url: "http://localhost:8080/provinces/update/" + vData.id,
          data: JSON.stringify(vData),
          contentType: "application/json;charset=UTF-8",
          success: function (response) {
            console.log(response);
          },
          error: function (e) {
            console.log(e); // in error state
          }

        });
      }
    }

    // xóa đối tượng 

    function deldeteHuyenClick() {
      console.log("delete huyen click");
      //1 đọc 

      var vData = getReadHuyenData();
      console.log(vData);
      //2 validate bỏ qua 
      if (vData.id != "") {
        console.log("id khác rỗng ")
        //3 gọi api 
        $.ajax({
          type: "DELETE",
          url: "http://localhost:8080/district/delete/" + vData.id,

          success: function (response) {
            console.log(response);
          },
          error: function (e) {
            console.log(e); // in error state
          }

        });
      }
    }



     //> CRUD tỉnh thành phố
    //  =================================================================
   



     //Get data tỉnh thành phố
    function getReadTinhData() {
      var dataTinh = {
        name: "",
        code: "",
        id: ""
      }
      dataTinh.name = $("#inp-ten-tinh").val();
      dataTinh.code = $("#inp-ma-tinh").val();
      dataTinh.id = $("#inp-tinh-id").val();

      return dataTinh;

    }
    // read data huyện quận 
    function getReadHuyenData() {
      var dataHuyen = {
        name: "",
        prefix: "",
        province: "",
        id: ""
      }
      dataHuyen.name = $("#ipn-ten-quan-huyen").val();
      dataHuyen.prefix = $("#inp-prefix-quan-huyen").val();
      dataHuyen.province = $("#tinh-select-id-quan-huyen").val();
      dataHuyen.id = $("#inp-id-huyen-delete").val();

      return dataHuyen;

    }



   



    $.ajax({
      url: "http://localhost:8080/provinces",
      method: "GET",
      success: function (pObjRes) {
        console.log(pObjRes);
        loadDataToCountrySelect(pObjRes);
      },
      error: function (pXhrObj) {
        console.log(pXhrObj);
      }
    });

    var gTinhSelectElement = $(".tinh-select");

    function loadDataToCountrySelect(pCountryList) {
      for (i = 0; i < pCountryList.length; i++) {
        var bCountryOption = $("<option/>");
        bCountryOption.prop("value", pCountryList[i].id);
        bCountryOption.prop("text", pCountryList[i].name);
        gTinhSelectElement.append(bCountryOption);
      };
    }

    var gQuanHuyenSelectElement = $(".quan-huyen-select");

    //callback function   nếu như có click change thì thực hiện hàm sau 
    gTinhSelectElement.on("change", function () {
      gQuanHuyenSelectElement.html("");
      var bCountryCode = $(this).val();  // lấy id của tỉnh thành phố

      getRegionsByCountryCode(bCountryCode);   // lấy thông tin các quận huyện qua các id của tỉnh thành phố
    });

    // lấy thông tin các quận huyện qua các id của tỉnh thành phố
    function getRegionsByCountryCode(pCountryCode) {
      $.ajax({
        url: "http://localhost:8080/district/list?province=" + pCountryCode, // get api qua id 
        method: "GET",   // phương thức get 
        success: function (pObjRes) {
          console.log(pObjRes);
          loadDataQuanHuyenSelect(pObjRes);   // load json trả về ra select 
        },
        error: function (pXhrObj) {
          console.log(pXhrObj);
        }
      });
    }
    // load json trả về ra select 
    function loadDataQuanHuyenSelect(pRegionList) {   //// load json trả về ra select 
      if (pRegionList.length > 0) {

        for (i = 0; i < pRegionList.length; i++) {
          var bRegionOption = $("<option/>");
          bRegionOption.prop("value", pRegionList[i].id);
          bRegionOption.prop("text", pRegionList[i].name);
          gQuanHuyenSelectElement.append(bRegionOption);
        };

      }
    }

    var gPhuongXaSelectElement = $(".phuong-xa-select");
    //callback function   nếu như có click change thì thực hiện hàm sau 
    gQuanHuyenSelectElement.on("change", function () {
      gPhuongXaSelectElement.html("");
      var bCountryCode = $(this).val();  // lấy id của phuong xã

      getPhuonngXaByHuyuenCode(bCountryCode);   // lấy thông tin các quận huyện qua các id của phuong xã
    });

    // lấy thông tin các xã   qua các id của tỉnh thành phố
    function getPhuonngXaByHuyuenCode(pHuyenId) {
      $.ajax({
        url: "http://localhost:8080/ward/list?districtId=" + pHuyenId, // get api qua id 
        method: "GET",   // phương thức get 
        success: function (pObjRes) {
          console.log(pObjRes);
          loadDataPhuongXaSelect(pObjRes);   // load json trả về ra select 
        },
        error: function (pXhrObj) {
          console.log(pXhrObj);
        }
      });
    }

    // load json trả về ra select  phường xã 
    function loadDataPhuongXaSelect(pRegionList) {   //// load json trả về ra select  phường xã 
      if (pRegionList.length > 0) {

        for (i = 0; i < pRegionList.length; i++) {
          var bRegionOption = $("<option/>");
          bRegionOption.prop("value", pRegionList[i].id);
          bRegionOption.prop("text", pRegionList[i].name);
          gPhuongXaSelectElement.append(bRegionOption);
        };
      }
    }


    // CRUD tỉnh thành phố
    // 1 add thành phố 







  </script>
</body>

</html>